#!/system/bin/sh
TMOBILE_PATH="/data/data/com.tmobile.myfaves/databases/"
NORMAL_PATH="/data/data/com.android.providers.contacts/databases/"

BUILD_ID=`getprop ro.build.id`
case "$BUILD_ID" in
UNLOCKED)
	echo "ADP1 ROM found."
	DB_PATH=$NORMAL_PATH
	;;
TC4-RC30)
	echo "RC30 ROM found."
	DB_PATH=$TMOBILE_PATH
	;;
PLAT-RC33)
	echo "RC33 ROM found."
	DB_PATH=$TMOBILE_PATH
	;;
TC5-RC8)
	echo "RC8 ROM found."
	DB_PATH=$NORMAL_PATH
	;;
PLATFORM-1_0)
	echo "EMULATOR ROM found."
	DB_PATH=$NORMAL_PATH
	;;
MAIN)
	echo "EMULATOR ROM found."
	DB_PATH=$NORMAL_PATH
	;;
TC3)
	echo "TC3 ROM found."
	DB_PATH=$NORMAL_PATH
	;;
TMI_RC9)
	echo "TC9 ROM found."
	DB_PATH=$NORMAL_PATH
	;;

*)
	echo "Unknown ROM ID: $BUILD_ID"
	echo "Try to use default contacts databases path"
	echo "Send the message above to sunner@gmail.com if it doesn't work"
	DB_PATH=$NORMAL_PATH
	;;
esac

cd $DB_PATH

echo 'Phase 1: Creating triggers...'
#Replace the offical trigger to index email address
sqlite3 contacts.db "DROP TRIGGER IF EXISTS peopleLookup_update;"
sqlite3 contacts.db \
"CREATE TRIGGER peopleLookup_update \
UPDATE OF name ON people \
BEGIN\
  DELETE FROM peopleLookup WHERE source = new._id;\
  SELECT _TOKENIZE('peopleLookup', new._id, new.name, ' ');\
  SELECT _TOKENIZE('peopleLookup', new._id, data, '')\
    FROM contact_methods\
	WHERE person=new._id AND kind=1; \
END" 

# Trig the peopleLookup_updats trigger
sqlite3 contacts.db "DROP TRIGGER IF EXISTS sunner_email_update;"
sqlite3 contacts.db \
"CREATE TRIGGER IF NOT EXISTS sunner_email_update \
AFTER UPDATE OF data ON contact_methods \
WHEN new.kind=1 \
BEGIN \
  UPDATE people SET name=\`name\` WHERE _id=new.person; \
END" 

sqlite3 contacts.db \
"CREATE TRIGGER IF NOT EXISTS sunner_email_insert \
AFTER INSERT ON contact_methods \
WHEN new.kind=1 \
BEGIN \
  SELECT _TOKENIZE('peopleLookup', new.person, new.data, ''); \
END" 

echo 'Phase 2: Updating database...slowly......'
sqlite3 contacts.db 'UPDATE people SET name=`name`;'
echo 'Phase 3: Reindexing database...'
sqlite3 contacts.db 'reindex peopleNameIndex;'
sqlite3 contacts.db 'reindex peopleLookupIndex;'
echo 'Finish! Enjoy Android! Enjoy Open Source!'
echo 'Send comments and donation to sunner@gmail.com'
